#! /usr/bin/python
# -*- coding: utf-8 -*-
# Copyright Fabrice Silva, 2012.

"""
Utilities
"""
import warnings

try:
    import h5py
    import hdf5pickle as pickle
    method = 'hdf5'
except ImportError:
    import cPickle as pickle
    method = 'basic'


## Serialization
# TODO : add moreesc version in saved files.
def _pickle(obj, fileobj):
    " Serialize Profile. "
    if method == 'hdf5':
        if not(isinstance(fileobj, h5py.File)):
            fileobj = h5py.File(fileobj, 'w')
        pickle.dump(obj, fileobj, "/%s" % type(obj).__name__)
    elif method == 'basic':
        if not(isinstance(fileobj, file)):
            fileobj = file(fileobj, 'wb')
        pickle.dump(obj, fileobj, pickle.HIGHEST_PROTOCOL)
    else:
        raise IOError()
    fileobj.close()
    return


def _unpickle(fileobj, path=None):
    " Deserialize Profile. "
    print fileobj
    if method == 'hdf5':
        if not(isinstance(fileobj, h5py.File)):
            f = h5py.File(fileobj, 'r')
        if path is None:
            children = f.values()
            if len(children) == 1:
                path = children[0].name
            else:
                raise IOError("Too much objects in the root group.")

        try:
            obj = pickle.load(f, path)
            return obj
        except:
            pass

    try:
        import cPickle
        obj = cPickle.load(file(fileobj, 'r'))
    except:
        raise IOError(u'Failed to open file.')
    return obj

__pickle_common_doc = """
Load data saved with the :meth:`%(class)s.save` method:

Parameters
----------
filename: file-like object (file or string)
  Name of the file to load.

Returns
-------
obj: %(output)s
  Stored %(class)s
"""
